ON_Brep Class Reference

`#include <pcl/surface/3rdparty/opennurbs/opennurbs_brep.h>`

Inheritance diagram for ON_Brep:

## Public Member Functions

void | DestroyRuntimeCache (bool bDelete=true)
unsigned int | SizeOf () const
ON__UINT32 | DataCRC (ON__UINT32 current_remainder) const
bool | EvaluatePoint (const class ON_ObjRef &objref, ON_3dPoint &P) const
| ON_Brep ()
| ~ON_Brep ()
| ON_Brep (const ON_Brep &)
ON_Brep & | operator= (const ON_Brep &)
void | MemoryRelocate ()
bool | IsDuplicate (const ON_Brep &other, double tolerance=ON_ZERO_TOLERANCE) const
void | Destroy ()
void | EmergencyDestroy ()
int | CreateMesh (const ON_MeshParameters &mp, ON_SimpleArray< ON_Mesh * > &mesh_list) const
void | DestroyMesh (ON::mesh_type mesh_type, bool bDeleteMesh=true)
int | GetMesh (ON::mesh_type mesh_type, ON_SimpleArray< const ON_Mesh * > &meshes) const
bool | Create (ON_Surface *&pSurface)
bool | Create (ON_NurbsSurface *&pNurbsSurface)
bool | Create (ON_PlaneSurface *&pPlaneSurface)
bool | Create (ON_RevSurface *&pRevSurface)
bool | Create (ON_SumSurface *&pSumSurface)
ON_BOOL32 | IsValid (ON_TextLog *text_log=NULL) const
bool | IsValidTopology (ON_TextLog *text_log=NULL) const
bool | IsValidGeometry (ON_TextLog *text_log=NULL) const
bool | IsValidTolerancesAndFlags (ON_TextLog *text_log=NULL) const
bool | IsValidForV2 () const
bool | IsValidForV2 (const ON_BrepTrim &) const
bool | IsValidForV2 (const ON_BrepEdge &) const
void | Dump (ON_TextLog &) const
ON_BOOL32 | Write (ON_BinaryArchive &) const
ON_BOOL32 | Read (ON_BinaryArchive &)
ON::object_type | ObjectType () const
int | Dimension () const
void | ClearBoundingBox ()
ON_BOOL32 | GetBBox (double *, double *, ON_BOOL32=false) const
ON_BOOL32 | Transform (const ON_Xform &)
ON_BOOL32 | SwapCoordinates (int, int)
ON_BOOL32 | HasBrepForm () const
ON_Brep * | BrepForm (ON_Brep *brep=NULL) const
int | AddTrimCurve (ON_Curve *)
int | AddEdgeCurve (ON_Curve *)
int | AddSurface (ON_Surface *)
bool | SetEdgeCurve (ON_BrepEdge &edge, int c3_index, const ON_Interval *sub_domain=NULL)
bool | SetTrimCurve (ON_BrepTrim &trim, int c2_index, const ON_Interval *sub_domain=NULL)
ON_BrepVertex & | NewVertex ()
ON_BrepVertex & | NewVertex (ON_3dPoint vertex_point, double vertex_tolerance=ON_UNSET_VALUE)
ON_BrepEdge & | NewEdge (int=-1)
ON_BrepEdge & | NewEdge (ON_BrepVertex &, ON_BrepVertex &, int=-1, const ON_Interval *=NULL, double edge_tolerance=ON_UNSET_VALUE)
ON_BrepFace & | NewFace (int si=-1)
ON_BrepFace * | NewFace (const ON_Surface &surface)
ON_BrepFace * | NewFace (ON_Surface *pSurface, int vid[4], int eid[4], ON_BOOL32 bRev3d[4])
ON_BrepFace * | NewRuledFace (const ON_BrepEdge &edgeA, bool bRevEdgeA, const ON_BrepEdge &edgeB, bool bRevEdgeB)
ON_BrepFace * | NewConeFace (const ON_BrepVertex &vertex, const ON_BrepEdge &edge, bool bRevEdge)
ON_BrepLoop & | NewLoop (ON_BrepLoop::TYPE)
ON_BrepLoop & | NewLoop (ON_BrepLoop::TYPE loop_type, ON_BrepFace &face)
ON_BrepLoop * | NewOuterLoop (int face_index)
ON_BrepLoop * | NewOuterLoop (int face_index, int vid[4], int eid[4], ON_BOOL32 bRev3d[4])
bool | NewPlanarFaceLoop (int face_index, ON_BrepLoop::TYPE loop_type, ON_SimpleArray< ON_Curve * > &boundary, ON_BOOL32 bDuplicateCurves=true)
ON_BrepTrim & | NewTrim (int c2i=-1)
ON_BrepTrim & | NewTrim (ON_BOOL32 bRev3d, ON_BrepLoop &loop, int c2i=-1)
ON_BrepTrim & | NewTrim (ON_BrepEdge &edge, ON_BOOL32 bRev3d, int c2i=-1)
ON_BrepTrim & | NewTrim (ON_BrepEdge &edge, ON_BOOL32 bRev3d, ON_BrepLoop &loop, int c2i=-1)
ON_BrepTrim & | NewSingularTrim (const ON_BrepVertex &vertex, ON_BrepLoop &loop, ON_Surface::ISO iso, int c2i=-1)
ON_BrepVertex & | NewPointOnFace (ON_BrepFace &face, double s, double t)
ON_BrepTrim & | NewCurveOnFace (ON_BrepFace &face, ON_BrepEdge &edge, ON_BOOL32 bRev3d=false, int c2i=-1)
void | Append (const ON_Brep &)
void | SetVertices (void)
bool | SetTrimIsoFlags ()
bool | SetTrimIsoFlags (ON_BrepFace &)
bool | SetTrimIsoFlags (ON_BrepLoop &)
bool | SetTrimIsoFlags (ON_BrepTrim &)
ON_BrepTrim::TYPE | TrimType (const ON_BrepTrim &trim, ON_BOOL32 bLazy=true) const
bool | SetTrimTypeFlags (ON_BOOL32 bLazy=false)
bool | SetTrimTypeFlags (ON_BrepFace &, ON_BOOL32 bLazy=false)
bool | SetTrimTypeFlags (ON_BrepLoop &, ON_BOOL32 bLazy=false)
bool | SetTrimTypeFlags (ON_BrepTrim &, ON_BOOL32 bLazy=false)
bool | GetTrim2dStart (int trim_index, ON_2dPoint &) const
bool | GetTrim2dEnd (int, ON_2dPoint &) const
bool | GetTrim3dStart (int, ON_3dPoint &) const
bool | GetTrim3dEnd (int, ON_3dPoint &) const
ON_BrepLoop::TYPE | ComputeLoopType (const ON_BrepLoop &) const
bool | SetVertexTolerance (ON_BrepVertex &vertex, ON_BOOL32 bLazy=false) const
virtual bool | SetTrimTolerance (ON_BrepTrim &trim, ON_BOOL32 bLazy=false) const
virtual bool | SetEdgeTolerance (ON_BrepEdge &edge, ON_BOOL32 bLazy=false) const
bool | SetVertexTolerances (ON_BOOL32 bLazy=false)
bool | SetTrimTolerances (ON_BOOL32 bLazy=false)
bool | SetEdgeTolerances (ON_BOOL32 bLazy=false)
virtual bool | SetTrimBoundingBox (ON_BrepTrim &trim, ON_BOOL32 bLazy=false)
virtual bool | SetTrimBoundingBoxes (ON_BrepLoop &loop, ON_BOOL32 bLazy=false)
virtual bool | SetTrimBoundingBoxes (ON_BrepFace &face, ON_BOOL32 bLazy=false)
virtual bool | SetTrimBoundingBoxes (ON_BOOL32 bLazy=false)
void | SetTolerancesBoxesAndFlags (ON_BOOL32 bLazy=false, ON_BOOL32 bSetVertexTolerances=true, ON_BOOL32 bSetEdgeTolerances=true, ON_BOOL32 bSetTrimTolerances=true, ON_BOOL32 bSetTrimIsoFlags=true, ON_BOOL32 bSetTrimTypeFlags=true, ON_BOOL32 bSetLoopTypeFlags=true, ON_BOOL32 bSetTrimBoxes=true)
int | SurfaceUseCount (int surface_index, int max_count=0) const
int | EdgeCurveUseCount (int c3_index, int max_count=0) const
int | TrimCurveUseCount (int c2_index, int max_count=0) const
ON_Curve * | Loop3dCurve (const ON_BrepLoop &loop, ON_BOOL32 bRevCurveIfFaceRevIsTrue=false) const
int | Loop3dCurve (const ON_BrepLoop &loop, ON_SimpleArray< ON_Curve * > &curve_list, ON_BOOL32 bRevCurveIfFaceRevIsTrue=false) const
ON_Curve * | Loop2dCurve (const ON_BrepLoop &loop) const
virtual int | SolidOrientation () const
bool | IsSolid () const
bool | IsManifold (ON_BOOL32 *pbIsOriented=NULL, ON_BOOL32 *pbHasBoundary=NULL) const
bool | IsPointInside (ON_3dPoint P, double tolerance, bool bStrictlyInside) const
bool | IsSurface () const
bool | FaceIsSurface (int) const
bool | LoopIsSurfaceBoundary (int) const
bool | FlipReversedSurfaces ()
bool | SetTrimDomain (int, const ON_Interval &)
bool | SetEdgeDomain (int, const ON_Interval &)
void | Flip ()
void | FlipFace (ON_BrepFace &)
void | FlipLoop (ON_BrepLoop &)
int | LoopDirection (const ON_BrepLoop &) const
bool | SortFaceLoops (ON_BrepFace &face) const
bool | CombineCoincidentVertices (ON_BrepVertex &, ON_BrepVertex &)
bool | CombineCoincidentEdges (ON_BrepEdge &, ON_BrepEdge &)
ON_BrepEdge * | CombineContiguousEdges (int edge_index0, int edge_iindex1, double angle_tolerance_radians=ON_PI/180.0)
void | DeleteVertex (ON_BrepVertex &vertex)
void | DeleteEdge (ON_BrepEdge &edge, ON_BOOL32 bDeleteEdgeVertices)
void | DeleteTrim (ON_BrepTrim &trim, ON_BOOL32 bDeleteTrimEdges)
void | DeleteLoop (ON_BrepLoop &loop, ON_BOOL32 bDeleteLoopEdges)
void | DeleteFace (ON_BrepFace &face, ON_BOOL32 bDeleteFaceEdges)
void | DeleteSurface (int s_index)
void | Delete2dCurve (int c2_index)
void | Delete3dCurve (int c3_index)
void | LabelConnectedComponent (int face_index, int label)
int | LabelConnectedComponents ()
int | GetConnectedComponents (ON_SimpleArray< ON_Brep * > &components, bool bDuplicateMeshes) const
ON_Brep * | SubBrep (int subfi_count, const int *sub_fi, ON_Brep *sub_brep=0) const
bool | HasRegionTopology () const
const ON_BrepRegionTopology & | RegionTopology () const
void | DestroyRegionTopology ()
ON_Brep * | DuplicateFace (int face_index, ON_BOOL32 bDuplicateMeshes) const
ON_Brep * | DuplicateFaces (int face_count, const int *face_index, ON_BOOL32 bDuplicateMeshes) const
ON_Brep * | ExtractFace (int face_index)
bool | StandardizeEdgeCurve (int edge_index, bool bAdjustEnds)
bool | StandardizeEdgeCurve (int edge_index, bool bAdjustEnds, int EdgeCurveUse)
void | StandardizeEdgeCurves (bool bAdjustEnds)
bool | StandardizeTrimCurve (int trim_index)
void | StandardizeTrimCurves ()
bool | StandardizeFaceSurface (int face_index)
void | StandardizeFaceSurfaces ()
ON_DEPRECATED void | StardardizeFaceSurfaces ()
void | Standardize ()
bool | ShrinkSurface (ON_BrepFace &face, int DisableSide=0)
bool | ShrinkSurfaces ()
bool | Compact ()
bool | CullUnusedFaces ()
bool | CullUnusedLoops ()
bool | CullUnusedTrims ()
bool | CullUnusedEdges ()
bool | CullUnusedVertices ()
bool | CullUnused3dCurves ()
bool | CullUnused2dCurves ()
bool | CullUnusedSurfaces ()
int | PrevTrim (int) const
int | NextTrim (int) const
int | PrevEdge (int current_edge_index, int endi, int *prev_endi=NULL) const
int | NextEdge (int current_edge_index, int endi, int *next_endi=NULL) const
const ON_Geometry * | BrepComponent (ON_COMPONENT_INDEX ci) const
ON_BrepVertex * | Vertex (int vertex_index) const
ON_BrepVertex * | Vertex (ON_COMPONENT_INDEX vertex_index) const
ON_BrepEdge * | Edge (int edge_index) const
ON_BrepEdge * | Edge (ON_COMPONENT_INDEX edge_index) const
ON_BrepTrim * | Trim (int trim_index) const
ON_BrepTrim * | Trim (ON_COMPONENT_INDEX trim_index) const
ON_BrepLoop * | Loop (int loop_index) const
ON_BrepLoop * | Loop (ON_COMPONENT_INDEX loop_index) const
ON_BrepFace * | Face (int face_index) const
ON_BrepFace * | Face (ON_COMPONENT_INDEX face_index) const
bool | RemoveSlits ()
bool | RemoveSlits (ON_BrepFace &F)
int | MergeFaces (int fid0, int fid1)
bool | MergeFaces ()
bool | RemoveNesting (bool bExtractSingleSegments, bool bEdges=true, bool bTrimCurves=true)
bool | CollapseEdge (int edge_index, bool bCloseTrimGap=true, int vertex_index=-1)
bool | ChangeVertex (int old_vi, int new_vi, bool bClearTolerances)
bool | CloseTrimGap (ON_BrepTrim &trim0, ON_BrepTrim &trim1)
int | RemoveWireEdges (bool bDeleteVertices=true)
int | RemoveWireVertices ()
void | Set_user (ON_U u)
void | Clear_vertex_user_i ()
void | Clear_edge_user_i (int)
void | Clear_edge_user_i ()
void | Clear_trim_user_i ()
void | Clear_loop_user_i ()
void | Clear_face_user_i ()
void | Clear_user_i ()
Public Member Functions inherited from ON_Geometry
| ON_Geometry ()
| ON_Geometry (const ON_Geometry &)
ON_Geometry & | operator= (const ON_Geometry &)
virtual | ~ON_Geometry ()
ON_BoundingBox | BoundingBox () const
ON_BOOL32 | GetBoundingBox (ON_BoundingBox &bbox, int bGrowBox=false) const
ON_BOOL32 | GetBoundingBox (ON_3dPoint &bbox_min, ON_3dPoint &bbox_max, int bGrowBox=false) const
ON_BOOL32 | Rotate (double sin_angle, double cos_angle, const ON_3dVector &rotation_axis, const ON_3dPoint &rotation_center)
ON_BOOL32 | Rotate (double rotation_angle, const ON_3dVector &rotation_axis, const ON_3dPoint &rotation_center)
ON_BOOL32 | Translate (const ON_3dVector &translation_vector)
ON_BOOL32 | Scale (double scale_factor)
virtual bool | GetTightBoundingBox (ON_BoundingBox &tight_bbox, int bGrowBox=false, const ON_Xform *xform=0) const
virtual bool | IsDeformable () const
virtual bool | MakeDeformable ()
virtual ON_COMPONENT_INDEX | ComponentIndex () const
Public Member Functions inherited from ON_Object
bool | CopyFrom (const ON_Object *src)
| ON_Object ()
| ON_Object (const ON_Object &)
ON_Object & | operator= (const ON_Object &)
virtual | ~ON_Object ()
void | EmergencyDestroy ()
ON_BOOL32 | IsKindOf (const ON_ClassId *pClassId) const
virtual ON_UUID | ModelObjectId () const
bool | SetUserString (const wchar_t *key, const wchar_t *string_value)
int | SetUserStrings (int count, const ON_UserString *user_strings, bool bReplace)
bool | GetUserString (const wchar_t *key, ON_wString &string_value) const
int | GetUserStrings (ON_ClassArray< ON_UserString > &user_strings) const
int | GetUserStringKeys (ON_ClassArray< ON_wString > &user_string_keys) const
int | UserStringCount () const
ON_BOOL32 | AttachUserData (ON_UserData *pUserData)
ON_BOOL32 | DetachUserData (ON_UserData *pUserData)
ON_UserData * | GetUserData (const ON_UUID &userdata_uuid) const
void | PurgeUserData ()
ON_UserData * | FirstUserData () const
void | TransformUserData (const ON_Xform &xform)
void | CopyUserData (const ON_Object &source_object)
void | MoveUserData (ON_Object &source_object)

## Static Public Member Functions

static ON_Brep * | New ()
static ON_Brep * | New (const ON_Brep &)

## Public Attributes

ON_U | m_brep_user
ON_CurveArray | m_C2
ON_CurveArray | m_C3
ON_SurfaceArray | m_S
ON_BrepVertexArray | m_V
ON_BrepEdgeArray | m_E
ON_BrepTrimArray | m_T
ON_BrepLoopArray | m_L
ON_BrepFaceArray | m_F

## Protected Member Functions

void | Initialize ()
void | SetTrimIsoFlag (int, double[6])
void | SetTrimIsoFlag (int)
bool | SetEdgeVertex (const int, const int, const int)
bool | HopAcrossEdge (int &, int &) const
bool | SetTrimStartVertex (const int, const int)
void | SetLoopVertices (const int)
void | ClearTrimVertices ()
void | ClearEdgeVertices ()
bool | SwapLoopParameters (int)
bool | SwapTrimParameters (int)
bool | IsValidTrim (int trim_index, ON_TextLog *text_log) const
bool | IsValidTrimTopology (int trim_index, ON_TextLog *text_log) const
bool | IsValidTrimGeometry (int trim_index, ON_TextLog *text_log) const
bool | IsValidTrimTolerancesAndFlags (int trim_index, ON_TextLog *text_log) const
bool | IsValidLoop (int loop_index, ON_TextLog *text_log) const
bool | IsValidLoopTopology (int loop_index, ON_TextLog *text_log) const
bool | IsValidLoopGeometry (int loop_index, ON_TextLog *text_log) const
bool | IsValidLoopTolerancesAndFlags (int loop_index, ON_TextLog *text_log) const
bool | IsValidFace (int face_index, ON_TextLog *text_log) const
bool | IsValidFaceTopology (int face_index, ON_TextLog *text_log) const
bool | IsValidFaceGeometry (int face_index, ON_TextLog *text_log) const
bool | IsValidFaceTolerancesAndFlags (int face_index, ON_TextLog *text_log) const
bool | IsValidEdge (int edge_index, ON_TextLog *text_log) const
bool | IsValidEdgeTopology (int edge_index, ON_TextLog *text_log) const
bool | IsValidEdgeGeometry (int edge_index, ON_TextLog *text_log) const
bool | IsValidEdgeTolerancesAndFlags (int edge_index, ON_TextLog *text_log) const
bool | IsValidVertex (int vertex_index, ON_TextLog *text_log) const
bool | IsValidVertexTopology (int vertex_index, ON_TextLog *text_log) const
bool | IsValidVertexGeometry (int vertex_index, ON_TextLog *text_log) const
bool | IsValidVertexTolerancesAndFlags (int vertex_index, ON_TextLog *text_log) const
void | SetTolsFromLegacyValues ()
bool | ReadOld100 (ON_BinaryArchive &)
bool | ReadOld101 (ON_BinaryArchive &)
bool | ReadOld200 (ON_BinaryArchive &, int)
ON_Curve * | Read100_BrepCurve (ON_BinaryArchive &) const
ON_Surface * | Read100_BrepSurface (ON_BinaryArchive &) const
bool | ReadV1_LegacyTrimStuff (ON_BinaryArchive &, ON_BrepFace &, ON_BrepLoop &)
bool | ReadV1_LegacyTrim (ON_BinaryArchive &, ON_BrepFace &, ON_BrepLoop &)
bool | ReadV1_LegacyLoopStuff (ON_BinaryArchive &, ON_BrepFace &)
bool | ReadV1_LegacyLoop (ON_BinaryArchive &, ON_BrepFace &)
bool | ReadV1_LegacyFaceStuff (ON_BinaryArchive &)
bool | ReadV1_LegacyShellStuff (ON_BinaryArchive &)

## Protected Attributes

ON_BoundingBox | m_bbox
int | m_is_solid

## Friends

class | ON_BrepFace
class | ON_BrepRegion
class | ON_BrepFaceSide
bool | ON_BinaryArchive::ReadV1_TCODE_LEGACY_FAC (ON_Object **, ON_3dmObjectAttributes *)
bool | ON_BinaryArchive::ReadV1_TCODE_LEGACY_SHL (ON_Object **, ON_3dmObjectAttributes *)

## Detailed Description

Definition at line 1570 of file opennurbs_brep.h.

## Constructor & Destructor Documentation

## ON_Brep() [1/2]

ON_Brep::ON_Brep | ( |  | ) |

## ~ON_Brep()

ON_Brep::~ON_Brep | ( |  | ) |

## ON_Brep() [2/2]

ON_Brep::ON_Brep | ( | const ON_Brep & |  | ) |

## Member Function Documentation

## AddEdgeCurve()

int ON_Brep::AddEdgeCurve | ( | ON_Curve * |  | ) |

## AddSurface()

int ON_Brep::AddSurface | ( | ON_Surface * |  | ) |

## AddTrimCurve()

int ON_Brep::AddTrimCurve | ( | ON_Curve * |  | ) |

## Append()

void ON_Brep::Append | ( | const ON_Brep & |  | ) |

## BrepComponent()

const ON_Geometry* ON_Brep::BrepComponent | ( | ON_COMPONENT_INDEX | ci | ) | const

## BrepForm()

ON_Brep* ON_Brep::BrepForm | ( | ON_Brep * | brep = `NULL` | ) | const

virtual

Reimplemented from ON_Geometry.

## ChangeVertex()

bool ON_Brep::ChangeVertex | ( | int | old_vi,
|  | int | new_vi,
|  | bool | bClearTolerances
| ) |  |

## Clear_edge_user_i() [1/2]

void ON_Brep::Clear_edge_user_i | ( |  | ) |

## Clear_edge_user_i() [2/2]

void ON_Brep::Clear_edge_user_i | ( | int |  | ) |

## Clear_face_user_i()

void ON_Brep::Clear_face_user_i | ( |  | ) |

## Clear_loop_user_i()

void ON_Brep::Clear_loop_user_i | ( |  | ) |

## Clear_trim_user_i()

void ON_Brep::Clear_trim_user_i | ( |  | ) |

## Clear_user_i()

void ON_Brep::Clear_user_i | ( |  | ) |

## Clear_vertex_user_i()

void ON_Brep::Clear_vertex_user_i | ( |  | ) |

## ClearBoundingBox()

void ON_Brep::ClearBoundingBox | ( |  | ) |

virtual

Reimplemented from ON_Geometry.

## ClearEdgeVertices()

void ON_Brep::ClearEdgeVertices | ( |  | ) |

protected

## ClearTrimVertices()

void ON_Brep::ClearTrimVertices | ( |  | ) |

protected

## CloseTrimGap()

bool ON_Brep::CloseTrimGap | ( | ON_BrepTrim & | trim0,
|  | ON_BrepTrim & | trim1
| ) |  |

## CollapseEdge()

bool ON_Brep::CollapseEdge | ( | int | edge_index,
|  | bool | bCloseTrimGap = `true`,
|  | int | vertex_index = `-1`
| ) |  |

## CombineCoincidentEdges()

bool ON_Brep::CombineCoincidentEdges | ( | ON_BrepEdge & | ,
|  | ON_BrepEdge & |
| ) |  |

## CombineCoincidentVertices()

bool ON_Brep::CombineCoincidentVertices | ( | ON_BrepVertex & | ,
|  | ON_BrepVertex & |
| ) |  |

## CombineContiguousEdges()

ON_BrepEdge* ON_Brep::CombineContiguousEdges | ( | int | edge_index0,
|  | int | edge_iindex1,
|  | double | angle_tolerance_radians = `ON_PI/180.0`
| ) |  |

## Compact()

bool ON_Brep::Compact | ( |  | ) |

## ComputeLoopType()

ON_BrepLoop::TYPE ON_Brep::ComputeLoopType | ( | const ON_BrepLoop & |  | ) | const

## Create() [1/5]

bool ON_Brep::Create | ( | ON_NurbsSurface *& | pNurbsSurface | ) |

## Create() [2/5]

bool ON_Brep::Create | ( | ON_PlaneSurface *& | pPlaneSurface | ) |

## Create() [3/5]

bool ON_Brep::Create | ( | ON_RevSurface *& | pRevSurface | ) |

## Create() [4/5]

bool ON_Brep::Create | ( | ON_SumSurface *& | pSumSurface | ) |

## Create() [5/5]

bool ON_Brep::Create | ( | ON_Surface *& | pSurface | ) |

## CreateMesh()

int ON_Brep::CreateMesh | ( | const ON_MeshParameters & | mp,
|  | ON_SimpleArray< ON_Mesh * > & | mesh_list
| ) |  | const

## CullUnused2dCurves()

bool ON_Brep::CullUnused2dCurves | ( |  | ) |

## CullUnused3dCurves()

bool ON_Brep::CullUnused3dCurves | ( |  | ) |

## CullUnusedEdges()

bool ON_Brep::CullUnusedEdges | ( |  | ) |

## CullUnusedFaces()

bool ON_Brep::CullUnusedFaces | ( |  | ) |

## CullUnusedLoops()

bool ON_Brep::CullUnusedLoops | ( |  | ) |

## CullUnusedSurfaces()

bool ON_Brep::CullUnusedSurfaces | ( |  | ) |

## CullUnusedTrims()

bool ON_Brep::CullUnusedTrims | ( |  | ) |

## CullUnusedVertices()

bool ON_Brep::CullUnusedVertices | ( |  | ) |

## DataCRC()

ON__UINT32 ON_Brep::DataCRC | ( | ON__UINT32 | current_remainder | ) | const

virtual

Reimplemented from ON_Object.

## Delete2dCurve()

void ON_Brep::Delete2dCurve | ( | int | c2_index | ) |

## Delete3dCurve()

void ON_Brep::Delete3dCurve | ( | int | c3_index | ) |

## DeleteEdge()

void ON_Brep::DeleteEdge | ( | ON_BrepEdge & | edge,
|  | ON_BOOL32 | bDeleteEdgeVertices
| ) |  |

## DeleteFace()

void ON_Brep::DeleteFace | ( | ON_BrepFace & | face,
|  | ON_BOOL32 | bDeleteFaceEdges
| ) |  |

## DeleteLoop()

void ON_Brep::DeleteLoop | ( | ON_BrepLoop & | loop,
|  | ON_BOOL32 | bDeleteLoopEdges
| ) |  |

## DeleteSurface()

void ON_Brep::DeleteSurface | ( | int | s_index | ) |

## DeleteTrim()

void ON_Brep::DeleteTrim | ( | ON_BrepTrim & | trim,
|  | ON_BOOL32 | bDeleteTrimEdges
| ) |  |

## DeleteVertex()

void ON_Brep::DeleteVertex | ( | ON_BrepVertex & | vertex | ) |

## Destroy()

void ON_Brep::Destroy | ( |  | ) |

## DestroyMesh()

void ON_Brep::DestroyMesh | ( | ON::mesh_type | mesh_type,
|  | bool | bDeleteMesh = `true`
| ) |  |

## DestroyRegionTopology()

void ON_Brep::DestroyRegionTopology | ( |  | ) |

## DestroyRuntimeCache()

void ON_Brep::DestroyRuntimeCache | ( | bool | bDelete = `true` | ) |

virtual

Reimplemented from ON_Object.

## Dimension()

int ON_Brep::Dimension | ( |  | ) | const

virtual

Implements ON_Geometry.

## Dump()

void ON_Brep::Dump | ( | ON_TextLog & |  | ) | const

virtual

Reimplemented from ON_Object.

## DuplicateFace()

ON_Brep* ON_Brep::DuplicateFace | ( | int | face_index,
|  | ON_BOOL32 | bDuplicateMeshes
| ) |  | const

## DuplicateFaces()

ON_Brep* ON_Brep::DuplicateFaces | ( | int | face_count,
|  | const int * | face_index,
|  | ON_BOOL32 | bDuplicateMeshes
| ) |  | const

## Edge() [1/2]

ON_BrepEdge* ON_Brep::Edge | ( | int | edge_index | ) | const

## Edge() [2/2]

ON_BrepEdge* ON_Brep::Edge | ( | ON_COMPONENT_INDEX | edge_index | ) | const

## EdgeCurveUseCount()

int ON_Brep::EdgeCurveUseCount | ( | int | c3_index,
|  | int | max_count = `0`
| ) |  | const

## EmergencyDestroy()

void ON_Brep::EmergencyDestroy | ( |  | ) |

## EvaluatePoint()

bool ON_Brep::EvaluatePoint | ( | const class ON_ObjRef & | objref,
|  | ON_3dPoint & | P
| ) |  | const

virtual

Reimplemented from ON_Geometry.

## ExtractFace()

ON_Brep* ON_Brep::ExtractFace | ( | int | face_index | ) |

## Face() [1/2]

ON_BrepFace* ON_Brep::Face | ( | int | face_index | ) | const

## Face() [2/2]

ON_BrepFace* ON_Brep::Face | ( | ON_COMPONENT_INDEX | face_index | ) | const

## FaceIsSurface()

bool ON_Brep::FaceIsSurface | ( | int |  | ) | const

## Flip()

void ON_Brep::Flip | ( |  | ) |

## FlipFace()

void ON_Brep::FlipFace | ( | ON_BrepFace & |  | ) |

## FlipLoop()

void ON_Brep::FlipLoop | ( | ON_BrepLoop & |  | ) |

## FlipReversedSurfaces()

bool ON_Brep::FlipReversedSurfaces | ( |  | ) |

## GetBBox()

ON_BOOL32 ON_Brep::GetBBox | ( | double * | ,
|  | double * | ,
|  | ON_BOOL32 | = `false`
| ) |  | const

virtual

Implements ON_Geometry.

## GetConnectedComponents()

int ON_Brep::GetConnectedComponents | ( | ON_SimpleArray< ON_Brep * > & | components,
|  | bool | bDuplicateMeshes
| ) |  | const

## GetMesh()

int ON_Brep::GetMesh | ( | ON::mesh_type | mesh_type,
|  | ON_SimpleArray< const ON_Mesh * > & | meshes
| ) |  | const

## GetTrim2dEnd()

bool ON_Brep::GetTrim2dEnd | ( | int | ,
|  | ON_2dPoint & |
| ) |  | const

## GetTrim2dStart()

bool ON_Brep::GetTrim2dStart | ( | int | trim_index,
|  | ON_2dPoint & |
| ) |  | const

## GetTrim3dEnd()

bool ON_Brep::GetTrim3dEnd | ( | int | ,
|  | ON_3dPoint & |
| ) |  | const

## GetTrim3dStart()

bool ON_Brep::GetTrim3dStart | ( | int | ,
|  | ON_3dPoint & |
| ) |  | const

## HasBrepForm()

ON_BOOL32 ON_Brep::HasBrepForm | ( |  | ) | const

virtual

Reimplemented from ON_Geometry.

## HasRegionTopology()

bool ON_Brep::HasRegionTopology | ( |  | ) | const

## HopAcrossEdge()

bool ON_Brep::HopAcrossEdge | ( | int & | ,
|  | int & |
| ) |  | const

protected

## Initialize()

void ON_Brep::Initialize | ( |  | ) |

protected

## IsDuplicate()

bool ON_Brep::IsDuplicate | ( | const ON_Brep & | other,
|  | double | tolerance = `ON_ZERO_TOLERANCE`
| ) |  | const

## IsManifold()

bool ON_Brep::IsManifold | ( | ON_BOOL32 * | pbIsOriented = `NULL`,
|  | ON_BOOL32 * | pbHasBoundary = `NULL`
| ) |  | const

## IsPointInside()

bool ON_Brep::IsPointInside | ( | ON_3dPoint | P,
|  | double | tolerance,
|  | bool | bStrictlyInside
| ) |  | const

## IsSolid()

bool ON_Brep::IsSolid | ( |  | ) | const

## IsSurface()

bool ON_Brep::IsSurface | ( |  | ) | const

## IsValid()

ON_BOOL32 ON_Brep::IsValid | ( | ON_TextLog * | text_log = `NULL` | ) | const

virtual

Implements ON_Object.

## IsValidEdge()

bool ON_Brep::IsValidEdge | ( | int | edge_index,
|  | ON_TextLog * | text_log
| ) |  | const

protected

## IsValidEdgeGeometry()

bool ON_Brep::IsValidEdgeGeometry | ( | int | edge_index,
|  | ON_TextLog * | text_log
| ) |  | const

protected

## IsValidEdgeTolerancesAndFlags()

bool ON_Brep::IsValidEdgeTolerancesAndFlags | ( | int | edge_index,
|  | ON_TextLog * | text_log
| ) |  | const

protected

## IsValidEdgeTopology()

bool ON_Brep::IsValidEdgeTopology | ( | int | edge_index,
|  | ON_TextLog * | text_log
| ) |  | const

protected

## IsValidFace()

bool ON_Brep::IsValidFace | ( | int | face_index,
|  | ON_TextLog * | text_log
| ) |  | const

protected

## IsValidFaceGeometry()

bool ON_Brep::IsValidFaceGeometry | ( | int | face_index,
|  | ON_TextLog * | text_log
| ) |  | const

protected

## IsValidFaceTolerancesAndFlags()

bool ON_Brep::IsValidFaceTolerancesAndFlags | ( | int | face_index,
|  | ON_TextLog * | text_log
| ) |  | const

protected

## IsValidFaceTopology()

bool ON_Brep::IsValidFaceTopology | ( | int | face_index,
|  | ON_TextLog * | text_log
| ) |  | const

protected

## IsValidForV2() [1/3]

bool ON_Brep::IsValidForV2 | ( |  | ) | const

## IsValidForV2() [2/3]

bool ON_Brep::IsValidForV2 | ( | const ON_BrepEdge & |  | ) | const

## IsValidForV2() [3/3]

bool ON_Brep::IsValidForV2 | ( | const ON_BrepTrim & |  | ) | const

## IsValidGeometry()

bool ON_Brep::IsValidGeometry | ( | ON_TextLog * | text_log = `NULL` | ) | const

## IsValidLoop()

bool ON_Brep::IsValidLoop | ( | int | loop_index,
|  | ON_TextLog * | text_log
| ) |  | const

protected

## IsValidLoopGeometry()

bool ON_Brep::IsValidLoopGeometry | ( | int | loop_index,
|  | ON_TextLog * | text_log
| ) |  | const

protected

## IsValidLoopTolerancesAndFlags()

bool ON_Brep::IsValidLoopTolerancesAndFlags | ( | int | loop_index,
|  | ON_TextLog * | text_log
| ) |  | const

protected

## IsValidLoopTopology()

bool ON_Brep::IsValidLoopTopology | ( | int | loop_index,
|  | ON_TextLog * | text_log
| ) |  | const

protected

## IsValidTolerancesAndFlags()

bool ON_Brep::IsValidTolerancesAndFlags | ( | ON_TextLog * | text_log = `NULL` | ) | const

## IsValidTopology()

bool ON_Brep::IsValidTopology | ( | ON_TextLog * | text_log = `NULL` | ) | const

## IsValidTrim()

bool ON_Brep::IsValidTrim | ( | int | trim_index,
|  | ON_TextLog * | text_log
| ) |  | const

protected

## IsValidTrimGeometry()

bool ON_Brep::IsValidTrimGeometry | ( | int | trim_index,
|  | ON_TextLog * | text_log
| ) |  | const

protected

## IsValidTrimTolerancesAndFlags()

bool ON_Brep::IsValidTrimTolerancesAndFlags | ( | int | trim_index,
|  | ON_TextLog * | text_log
| ) |  | const

protected

## IsValidTrimTopology()

bool ON_Brep::IsValidTrimTopology | ( | int | trim_index,
|  | ON_TextLog * | text_log
| ) |  | const

protected

## IsValidVertex()

bool ON_Brep::IsValidVertex | ( | int | vertex_index,
|  | ON_TextLog * | text_log
| ) |  | const

protected

## IsValidVertexGeometry()

bool ON_Brep::IsValidVertexGeometry | ( | int | vertex_index,
|  | ON_TextLog * | text_log
| ) |  | const

protected

## IsValidVertexTolerancesAndFlags()

bool ON_Brep::IsValidVertexTolerancesAndFlags | ( | int | vertex_index,
|  | ON_TextLog * | text_log
| ) |  | const

protected

## IsValidVertexTopology()

bool ON_Brep::IsValidVertexTopology | ( | int | vertex_index,
|  | ON_TextLog * | text_log
| ) |  | const

protected

## LabelConnectedComponent()

void ON_Brep::LabelConnectedComponent | ( | int | face_index,
|  | int | label
| ) |  |

## LabelConnectedComponents()

int ON_Brep::LabelConnectedComponents | ( |  | ) |

## Loop() [1/2]

ON_BrepLoop* ON_Brep::Loop | ( | int | loop_index | ) | const

## Loop() [2/2]

ON_BrepLoop* ON_Brep::Loop | ( | ON_COMPONENT_INDEX | loop_index | ) | const

## Loop2dCurve()

ON_Curve* ON_Brep::Loop2dCurve | ( | const ON_BrepLoop & | loop | ) | const

## Loop3dCurve() [1/2]

ON_Curve* ON_Brep::Loop3dCurve | ( | const ON_BrepLoop & | loop,
|  | ON_BOOL32 | bRevCurveIfFaceRevIsTrue = `false`
| ) |  | const

## Loop3dCurve() [2/2]

int ON_Brep::Loop3dCurve | ( | const ON_BrepLoop & | loop,
|  | ON_SimpleArray< ON_Curve * > & | curve_list,
|  | ON_BOOL32 | bRevCurveIfFaceRevIsTrue = `false`
| ) |  | const

## LoopDirection()

int ON_Brep::LoopDirection | ( | const ON_BrepLoop & |  | ) | const

## LoopIsSurfaceBoundary()

bool ON_Brep::LoopIsSurfaceBoundary | ( | int |  | ) | const

## MemoryRelocate()

void ON_Brep::MemoryRelocate | ( |  | ) |

virtual

Reimplemented from ON_Object.

## MergeFaces() [1/2]

bool ON_Brep::MergeFaces | ( |  | ) |

## MergeFaces() [2/2]

int ON_Brep::MergeFaces | ( | int | fid0,
|  | int | fid1
| ) |  |

## New() [1/2]

static ON_Brep* ON_Brep::New | ( |  | ) |

static

## New() [2/2]

static ON_Brep* ON_Brep::New | ( | const ON_Brep & |  | ) |

static

## NewConeFace()

ON_BrepFace* ON_Brep::NewConeFace | ( | const ON_BrepVertex & | vertex,
|  | const ON_BrepEdge & | edge,
|  | bool | bRevEdge
| ) |  |

## NewCurveOnFace()

ON_BrepTrim& ON_Brep::NewCurveOnFace | ( | ON_BrepFace & | face,
|  | ON_BrepEdge & | edge,
|  | ON_BOOL32 | bRev3d = `false`,
|  | int | c2i = `-1`
| ) |  |

## NewEdge() [1/2]

ON_BrepEdge& ON_Brep::NewEdge | ( | int | = `-1` | ) |

## NewEdge() [2/2]

ON_BrepEdge& ON_Brep::NewEdge | ( | ON_BrepVertex & | ,
|  | ON_BrepVertex & | ,
|  | int | = `-1`,
|  | const ON_Interval * | = `NULL`,
|  | double | edge_tolerance = `ON_UNSET_VALUE`
| ) |  |

## NewFace() [1/3]

ON_BrepFace* ON_Brep::NewFace | ( | const ON_Surface & | surface | ) |

## NewFace() [2/3]

ON_BrepFace& ON_Brep::NewFace | ( | int | si = `-1` | ) |

## NewFace() [3/3]

ON_BrepFace* ON_Brep::NewFace | ( | ON_Surface * | pSurface,
|  | int | vid[4],
|  | int | eid[4],
|  | ON_BOOL32 | bRev3d[4]
| ) |  |

## NewLoop() [1/2]

ON_BrepLoop& ON_Brep::NewLoop | ( | ON_BrepLoop::TYPE | loop_type,
|  | ON_BrepFace & | face
| ) |  |

## NewLoop() [2/2]

ON_BrepLoop& ON_Brep::NewLoop | ( | ON_BrepLoop::TYPE |  | ) |

## NewOuterLoop() [1/2]

ON_BrepLoop* ON_Brep::NewOuterLoop | ( | int | face_index | ) |

## NewOuterLoop() [2/2]

ON_BrepLoop* ON_Brep::NewOuterLoop | ( | int | face_index,
|  | int | vid[4],
|  | int | eid[4],
|  | ON_BOOL32 | bRev3d[4]
| ) |  |

## NewPlanarFaceLoop()

bool ON_Brep::NewPlanarFaceLoop | ( | int | face_index,
|  | ON_BrepLoop::TYPE | loop_type,
|  | ON_SimpleArray< ON_Curve * > & | boundary,
|  | ON_BOOL32 | bDuplicateCurves = `true`
| ) |  |

## NewPointOnFace()

ON_BrepVertex& ON_Brep::NewPointOnFace | ( | ON_BrepFace & | face,
|  | double | s,
|  | double | t
| ) |  |

## NewRuledFace()

ON_BrepFace* ON_Brep::NewRuledFace | ( | const ON_BrepEdge & | edgeA,
|  | bool | bRevEdgeA,
|  | const ON_BrepEdge & | edgeB,
|  | bool | bRevEdgeB
| ) |  |

## NewSingularTrim()

ON_BrepTrim& ON_Brep::NewSingularTrim | ( | const ON_BrepVertex & | vertex,
|  | ON_BrepLoop & | loop,
|  | ON_Surface::ISO | iso,
|  | int | c2i = `-1`
| ) |  |

## NewTrim() [1/4]

ON_BrepTrim& ON_Brep::NewTrim | ( | int | c2i = `-1` | ) |

## NewTrim() [2/4]

ON_BrepTrim& ON_Brep::NewTrim | ( | ON_BOOL32 | bRev3d,
|  | ON_BrepLoop & | loop,
|  | int | c2i = `-1`
| ) |  |

## NewTrim() [3/4]

ON_BrepTrim& ON_Brep::NewTrim | ( | ON_BrepEdge & | edge,
|  | ON_BOOL32 | bRev3d,
|  | int | c2i = `-1`
| ) |  |

## NewTrim() [4/4]

ON_BrepTrim& ON_Brep::NewTrim | ( | ON_BrepEdge & | edge,
|  | ON_BOOL32 | bRev3d,
|  | ON_BrepLoop & | loop,
|  | int | c2i = `-1`
| ) |  |

## NewVertex() [1/2]

ON_BrepVertex& ON_Brep::NewVertex | ( |  | ) |

## NewVertex() [2/2]

ON_BrepVertex& ON_Brep::NewVertex | ( | ON_3dPoint | vertex_point,
|  | double | vertex_tolerance = `ON_UNSET_VALUE`
| ) |  |

## NextEdge()

int ON_Brep::NextEdge | ( | int | current_edge_index,
|  | int | endi,
|  | int * | next_endi = `NULL`
| ) |  | const

## NextTrim()

int ON_Brep::NextTrim | ( | int |  | ) | const

## ObjectType()

ON::object_type ON_Brep::ObjectType | ( |  | ) | const

virtual

Reimplemented from ON_Object.

## operator=()

ON_Brep& ON_Brep::operator= | ( | const ON_Brep & |  | ) |

## PrevEdge()

int ON_Brep::PrevEdge | ( | int | current_edge_index,
|  | int | endi,
|  | int * | prev_endi = `NULL`
| ) |  | const

## PrevTrim()

int ON_Brep::PrevTrim | ( | int |  | ) | const

## Read()

ON_BOOL32 ON_Brep::Read | ( | ON_BinaryArchive & |  | ) |

virtual

Reimplemented from ON_Object.

## Read100_BrepCurve()

ON_Curve* ON_Brep::Read100_BrepCurve | ( | ON_BinaryArchive & |  | ) | const

protected

## Read100_BrepSurface()

ON_Surface* ON_Brep::Read100_BrepSurface | ( | ON_BinaryArchive & |  | ) | const

protected

## ReadOld100()

bool ON_Brep::ReadOld100 | ( | ON_BinaryArchive & |  | ) |

protected

## ReadOld101()

bool ON_Brep::ReadOld101 | ( | ON_BinaryArchive & |  | ) |

protected

## ReadOld200()

bool ON_Brep::ReadOld200 | ( | ON_BinaryArchive & | ,
|  | int |
| ) |  |

protected

## ReadV1_LegacyFaceStuff()

bool ON_Brep::ReadV1_LegacyFaceStuff | ( | ON_BinaryArchive & |  | ) |

protected

## ReadV1_LegacyLoop()

bool ON_Brep::ReadV1_LegacyLoop | ( | ON_BinaryArchive & | ,
|  | ON_BrepFace & |
| ) |  |

protected

## ReadV1_LegacyLoopStuff()

bool ON_Brep::ReadV1_LegacyLoopStuff | ( | ON_BinaryArchive & | ,
|  | ON_BrepFace & |
| ) |  |

protected

## ReadV1_LegacyShellStuff()

bool ON_Brep::ReadV1_LegacyShellStuff | ( | ON_BinaryArchive & |  | ) |

protected

## ReadV1_LegacyTrim()

bool ON_Brep::ReadV1_LegacyTrim | ( | ON_BinaryArchive & | ,
|  | ON_BrepFace & | ,
|  | ON_BrepLoop & |
| ) |  |

protected

## ReadV1_LegacyTrimStuff()

bool ON_Brep::ReadV1_LegacyTrimStuff | ( | ON_BinaryArchive & | ,
|  | ON_BrepFace & | ,
|  | ON_BrepLoop & |
| ) |  |

protected

## RegionTopology()

const ON_BrepRegionTopology& ON_Brep::RegionTopology | ( |  | ) | const

## RemoveNesting()

bool ON_Brep::RemoveNesting | ( | bool | bExtractSingleSegments,
|  | bool | bEdges = `true`,
|  | bool | bTrimCurves = `true`
| ) |  |

## RemoveSlits() [1/2]

bool ON_Brep::RemoveSlits | ( |  | ) |

## RemoveSlits() [2/2]

bool ON_Brep::RemoveSlits | ( | ON_BrepFace & | F | ) |

## RemoveWireEdges()

int ON_Brep::RemoveWireEdges | ( | bool | bDeleteVertices = `true` | ) |

## RemoveWireVertices()

int ON_Brep::RemoveWireVertices | ( |  | ) |

## Set_user()

void ON_Brep::Set_user | ( | ON_U | u | ) |

## SetEdgeCurve()

bool ON_Brep::SetEdgeCurve | ( | ON_BrepEdge & | edge,
|  | int | c3_index,
|  | const ON_Interval * | sub_domain = `NULL`
| ) |  |

## SetEdgeDomain()

bool ON_Brep::SetEdgeDomain | ( | int | ,
|  | const ON_Interval & |
| ) |  |

## SetEdgeTolerance()

virtual bool ON_Brep::SetEdgeTolerance | ( | ON_BrepEdge & | edge,
|  | ON_BOOL32 | bLazy = `false`
| ) |  | const

virtual

## SetEdgeTolerances()

bool ON_Brep::SetEdgeTolerances | ( | ON_BOOL32 | bLazy = `false` | ) |

## SetEdgeVertex()

bool ON_Brep::SetEdgeVertex | ( | const int | ,
|  | const int | ,
|  | const int |
| ) |  |

protected

## SetLoopVertices()

void ON_Brep::SetLoopVertices | ( | const int |  | ) |

protected

## SetTolerancesBoxesAndFlags()

void ON_Brep::SetTolerancesBoxesAndFlags | ( | ON_BOOL32 | bLazy = `false`,
|  | ON_BOOL32 | bSetVertexTolerances = `true`,
|  | ON_BOOL32 | bSetEdgeTolerances = `true`,
|  | ON_BOOL32 | bSetTrimTolerances = `true`,
|  | ON_BOOL32 | bSetTrimIsoFlags = `true`,
|  | ON_BOOL32 | bSetTrimTypeFlags = `true`,
|  | ON_BOOL32 | bSetLoopTypeFlags = `true`,
|  | ON_BOOL32 | bSetTrimBoxes = `true`
| ) |  |

## SetTolsFromLegacyValues()

void ON_Brep::SetTolsFromLegacyValues | ( |  | ) |

protected

## SetTrimBoundingBox()

virtual bool ON_Brep::SetTrimBoundingBox | ( | ON_BrepTrim & | trim,
|  | ON_BOOL32 | bLazy = `false`
| ) |  |

virtual

## SetTrimBoundingBoxes() [1/3]

virtual bool ON_Brep::SetTrimBoundingBoxes | ( | ON_BOOL32 | bLazy = `false` | ) |

virtual

## SetTrimBoundingBoxes() [2/3]

virtual bool ON_Brep::SetTrimBoundingBoxes | ( | ON_BrepFace & | face,
|  | ON_BOOL32 | bLazy = `false`
| ) |  |

virtual

## SetTrimBoundingBoxes() [3/3]

virtual bool ON_Brep::SetTrimBoundingBoxes | ( | ON_BrepLoop & | loop,
|  | ON_BOOL32 | bLazy = `false`
| ) |  |

virtual

## SetTrimCurve()

bool ON_Brep::SetTrimCurve | ( | ON_BrepTrim & | trim,
|  | int | c2_index,
|  | const ON_Interval * | sub_domain = `NULL`
| ) |  |

## SetTrimDomain()

bool ON_Brep::SetTrimDomain | ( | int | ,
|  | const ON_Interval & |
| ) |  |

## SetTrimIsoFlag() [1/2]

void ON_Brep::SetTrimIsoFlag | ( | int |  | ) |

protected

## SetTrimIsoFlag() [2/2]

void ON_Brep::SetTrimIsoFlag | ( | int | ,
|  | double | [6]
| ) |  |

protected

## SetTrimIsoFlags() [1/4]

bool ON_Brep::SetTrimIsoFlags | ( |  | ) |

## SetTrimIsoFlags() [2/4]

bool ON_Brep::SetTrimIsoFlags | ( | ON_BrepFace & |  | ) |

## SetTrimIsoFlags() [3/4]

bool ON_Brep::SetTrimIsoFlags | ( | ON_BrepLoop & |  | ) |

## SetTrimIsoFlags() [4/4]

bool ON_Brep::SetTrimIsoFlags | ( | ON_BrepTrim & |  | ) |

## SetTrimStartVertex()

bool ON_Brep::SetTrimStartVertex | ( | const int | ,
|  | const int |
| ) |  |

protected

## SetTrimTolerance()

virtual bool ON_Brep::SetTrimTolerance | ( | ON_BrepTrim & | trim,
|  | ON_BOOL32 | bLazy = `false`
| ) |  | const

virtual

## SetTrimTolerances()

bool ON_Brep::SetTrimTolerances | ( | ON_BOOL32 | bLazy = `false` | ) |

## SetTrimTypeFlags() [1/4]

bool ON_Brep::SetTrimTypeFlags | ( | ON_BOOL32 | bLazy = `false` | ) |

## SetTrimTypeFlags() [2/4]

bool ON_Brep::SetTrimTypeFlags | ( | ON_BrepFace & | ,
|  | ON_BOOL32 | bLazy = `false`
| ) |  |

## SetTrimTypeFlags() [3/4]

bool ON_Brep::SetTrimTypeFlags | ( | ON_BrepLoop & | ,
|  | ON_BOOL32 | bLazy = `false`
| ) |  |

## SetTrimTypeFlags() [4/4]

bool ON_Brep::SetTrimTypeFlags | ( | ON_BrepTrim & | ,
|  | ON_BOOL32 | bLazy = `false`
| ) |  |

## SetVertexTolerance()

bool ON_Brep::SetVertexTolerance | ( | ON_BrepVertex & | vertex,
|  | ON_BOOL32 | bLazy = `false`
| ) |  | const

## SetVertexTolerances()

bool ON_Brep::SetVertexTolerances | ( | ON_BOOL32 | bLazy = `false` | ) |

## SetVertices()

void ON_Brep::SetVertices | ( | void |  | ) |

## ShrinkSurface()

bool ON_Brep::ShrinkSurface | ( | ON_BrepFace & | face,
|  | int | DisableSide = `0`
| ) |  |

## ShrinkSurfaces()

bool ON_Brep::ShrinkSurfaces | ( |  | ) |

## SizeOf()

unsigned int ON_Brep::SizeOf | ( |  | ) | const

virtual

Reimplemented from ON_Object.

## SolidOrientation()

virtual int ON_Brep::SolidOrientation | ( |  | ) | const

virtual

## SortFaceLoops()

bool ON_Brep::SortFaceLoops | ( | ON_BrepFace & | face | ) | const

## Standardize()

void ON_Brep::Standardize | ( |  | ) |

## StandardizeEdgeCurve() [1/2]

bool ON_Brep::StandardizeEdgeCurve | ( | int | edge_index,
|  | bool | bAdjustEnds
| ) |  |

## StandardizeEdgeCurve() [2/2]

bool ON_Brep::StandardizeEdgeCurve | ( | int | edge_index,
|  | bool | bAdjustEnds,
|  | int | EdgeCurveUse
| ) |  |

## StandardizeEdgeCurves()

void ON_Brep::StandardizeEdgeCurves | ( | bool | bAdjustEnds | ) |

## StandardizeFaceSurface()

bool ON_Brep::StandardizeFaceSurface | ( | int | face_index | ) |

## StandardizeFaceSurfaces()

void ON_Brep::StandardizeFaceSurfaces | ( |  | ) |

## StandardizeTrimCurve()

bool ON_Brep::StandardizeTrimCurve | ( | int | trim_index | ) |

## StandardizeTrimCurves()

void ON_Brep::StandardizeTrimCurves | ( |  | ) |

## StardardizeFaceSurfaces()

ON_DEPRECATED void ON_Brep::StardardizeFaceSurfaces | ( |  | ) |

## SubBrep()

ON_Brep* ON_Brep::SubBrep | ( | int | subfi_count,
|  | const int * | sub_fi,
|  | ON_Brep * | sub_brep = `0`
| ) |  | const

## SurfaceUseCount()

int ON_Brep::SurfaceUseCount | ( | int | surface_index,
|  | int | max_count = `0`
| ) |  | const

## SwapCoordinates()

ON_BOOL32 ON_Brep::SwapCoordinates | ( | int | ,
|  | int |
| ) |  |

virtual

Reimplemented from ON_Geometry.

## SwapLoopParameters()

bool ON_Brep::SwapLoopParameters | ( | int |  | ) |

protected

## SwapTrimParameters()

bool ON_Brep::SwapTrimParameters | ( | int |  | ) |

protected

## Transform()

ON_BOOL32 ON_Brep::Transform | ( | const ON_Xform & |  | ) |

virtual

Reimplemented from ON_Geometry.

## Trim() [1/2]

ON_BrepTrim* ON_Brep::Trim | ( | int | trim_index | ) | const

## Trim() [2/2]

ON_BrepTrim* ON_Brep::Trim | ( | ON_COMPONENT_INDEX | trim_index | ) | const

## TrimCurveUseCount()

int ON_Brep::TrimCurveUseCount | ( | int | c2_index,
|  | int | max_count = `0`
| ) |  | const

## TrimType()

ON_BrepTrim::TYPE ON_Brep::TrimType | ( | const ON_BrepTrim & | trim,
|  | ON_BOOL32 | bLazy = `true`
| ) |  | const

## Vertex() [1/2]

ON_BrepVertex* ON_Brep::Vertex | ( | int | vertex_index | ) | const

## Vertex() [2/2]

ON_BrepVertex* ON_Brep::Vertex | ( | ON_COMPONENT_INDEX | vertex_index | ) | const

## Write()

ON_BOOL32 ON_Brep::Write | ( | ON_BinaryArchive & |  | ) | const

virtual

Reimplemented from ON_Object.

## Friends And Related Function Documentation

## ON_BinaryArchive::ReadV1_TCODE_LEGACY_FAC

bool ON_BinaryArchive::ReadV1_TCODE_LEGACY_FAC | ( | ON_Object ** | ,
|  | ON_3dmObjectAttributes * |
| ) |  |

friend

## ON_BinaryArchive::ReadV1_TCODE_LEGACY_SHL

bool ON_BinaryArchive::ReadV1_TCODE_LEGACY_SHL | ( | ON_Object ** | ,
|  | ON_3dmObjectAttributes * |
| ) |  |

friend

## ON_BrepFace

friend class ON_BrepFace

friend

Definition at line 3746 of file opennurbs_brep.h.

## ON_BrepFaceSide

friend class ON_BrepFaceSide

friend

Definition at line 3748 of file opennurbs_brep.h.

## ON_BrepRegion

friend class ON_BrepRegion

friend

Definition at line 3747 of file opennurbs_brep.h.

## Member Data Documentation

## m_bbox

ON_BoundingBox ON_Brep::m_bbox

protected

Definition at line 3749 of file opennurbs_brep.h.

## m_brep_user

ON_U ON_Brep::m_brep_user

Definition at line 3726 of file opennurbs_brep.h.

## m_C2

ON_CurveArray ON_Brep::m_C2

Definition at line 3731 of file opennurbs_brep.h.

## m_C3

ON_CurveArray ON_Brep::m_C3

Definition at line 3733 of file opennurbs_brep.h.

## m_E

ON_BrepEdgeArray ON_Brep::m_E

Definition at line 3740 of file opennurbs_brep.h.

## m_F

ON_BrepFaceArray ON_Brep::m_F

Definition at line 3743 of file opennurbs_brep.h.

## m_is_solid

int ON_Brep::m_is_solid

protected

Definition at line 3758 of file opennurbs_brep.h.

## m_L

ON_BrepLoopArray ON_Brep::m_L

Definition at line 3742 of file opennurbs_brep.h.

## m_S

ON_SurfaceArray ON_Brep::m_S

Definition at line 3734 of file opennurbs_brep.h.

## m_T

ON_BrepTrimArray ON_Brep::m_T

Definition at line 3741 of file opennurbs_brep.h.

## m_V

ON_BrepVertexArray ON_Brep::m_V

Definition at line 3739 of file opennurbs_brep.h.

The documentation for this class was generated from the following file:

- pcl/surface/3rdparty/opennurbs/opennurbs_brep.h